
#ifndef __CMD_H__
#define __CMD_H__

#define CMD_ERR_OK      0
#define CMD_ERR_INV     1
#define CMD_ERR_ACC     2
#define CMD_ERR_PARAMS  3
#define CMD_ERR_INDEX   4
#define CMD_ERR_HASH    5






struct cmdhash_ {

	char *name; //the name of the client this belongs to

	char *module; //The module the command is associated with.

	char access[128];

	int hashlp;

	int hashlpext;

	int hascmd;

	unsigned int entrycount;

	void (*fnct)(User*, char*);

};

typedef struct help_entry {
       
	void (*routine)(User*);

} HelpEntry;

static const unsigned int primes[] = {
 	  53,   97,
        193,   389,
	 769,   1543,
	3079,   6151,
	12289,  24593,
	49157,  98317,
	196613, 393241,
	786433, 1572869,
	3145739, 6291469,
	12582917, 25165843,
	50331653, 100663319,
	201326611, 402653189,
	805306457, 1610612741
};


int HELP_FOREACH(User*, User*);
int do_cmd(char *cmd, User* us, User *u, int ac, char *av);

void ACCESS_DENIED(User*,User*) ;

CmdHash* CmdHashCreate(User *u);


int  AddCmd (User *, char *,char *, void (*fnct)(User*,char*));
void DelCmd (User *, char *, void (*fnct)(User*,char*));

int AddHelpExt (int index,User* u, void (*helpcmd)(User*));

int AddHelp (User* u, void (*helpcmd)(User*));
int DelHelp (User *u, void (*helpcmd)(User*));


char *CmdErr   (int);

static void ClientCmdNull(User *u,char *av);

/******************************************************/
/**
 * Depreciated Stuff
 */


#endif //__CMD_H__
