#ifndef __SOCKETENGINE_H__
#define __SOCKETENGINE_H__

//#define MAXLEN 16384
#define MAXLEN 4096
#define MAXREADBUFFER MAXLEN*120+5

#define SOCK_UPLINK		0x00000001
#define SOCK_DCC		0x00000002
#define SOCK_DCCCONN	0x00000004
#define SOCK_WRITE		0x00000008
#define SOCK_READ		0x00000010
#define SOCK_NOREAD		0x00000020
#define SOCK_DEAD		0x00000040

#define SOCK_CONNECTING	0x00000080
#define SOCK_DCCIN		0x00000100
#define SOCK_DCCOUT		0x00000200

dlink_list	connected_sockets;
dlink_list	sockets;

time_t			rawtime;
struct tm		*timeinfo;

fd_set wfdset,rfdset,errfdset;

typedef struct
{
	char	message[MAXLEN];
} MessageBuffer;

typedef struct socket_
{
	int	sd;
	int	fullLines;
	int	dead;
	int	flags;

	int 	witems;
	int     ritems;

	char	read_buffer[MAXLEN + 1];
	char	name[512];

	dlink_list	mbuffer;
	dlink_list	sendq;

	struct sockaddr_in	*sa;

	User	*user;

	void	(*read_callback)  (struct socket_ *, int);

	void	(*write_callback) (void *);

	Thread* thread;

} Socket;

Socket  *add_new_socket(void (*read)(Socket*, int),void (*write)(void*));

Socket  *servsock;
Socket	*se_init 	();
Socket	*new_socket	();
Socket	*find_socket	(char *);

int		receive		(Socket*);
int		send_line	(char *, ...);
int		handle_msg	(char *);
int		Connect		(Socket *, char *, char *, int);
char	*GetLine	(Socket *);
void 	socket_cleanup();

void	se_HandleEvent	(void *);

struct in_addr *GetHost(char *address);

//sending TOKEN support
char *SendToken(char*,char*);

void send_cmd			(char*,char *,char *, ...);
void sendto_one			(User *, User *, char *, ...);
void sendto_one_privmsg (User *, User *, char *, ...);
void sendto_one_notice	(User *, User *, char *, ...);
void sendto_one_numeric (char *, User *, int, char *, ...);
void sendto_ircops		(User *, char *, ...);
void sendto_channel		(User*, Channel*, char*, ...);
void sendto_server		(User *, char *, ...);
int sendto_socket		(Socket *, char *, ...);

void uplink_cleanup (void *, int);
struct hostent *get_hostname(char *);

extern struct addrinfo * gethostinfo (char const *, int);

struct sendq {
	char	*buf;
	int		len;
	int		pos;
    int     s;

    struct sendq    *next;
    struct sendq    *prev;
};

dlink_list	sendq;

#endif //__SOCKETENGINE_H__



