#ifndef __USER_H__
#define __USER_H__

#define HasId(x)   		((x->uid[0] != '\0')? 1 : 0)
#define MyConnect(x)	       ((x->myconnect == 1)? 1 : 0)

dlink_list	userlist;

typedef struct USER User;
typedef void help_cmd(User*);

struct USER {
    time_t age;         //TS for the user structure :)

    char nick[30];      // Users nickname
    char host[63];      // Users actual hostname
    char virthost[63];  // Users virtual host
    char user[10];      // Users ident
    char realname[50];  // Users realname

    char	version[512];	// Users CTCP VERSION reply

    Link    *serv;      // Server the user is found on

	char uid[15];       // Users UID (used for TS6)

	char *ip;	    // IP a user is connecting from.

	int registered;     // using a registered nickname
	int oper;           // is an IRC Operator
	int ssl;            // is using a secure connection
	int bot;            // is a bot (not supported for all IRCds)
	int service;        // has service protection or is a network service
	int webtv;          // WebTV will make us use privmsg when we get to it ;)
	int cloak;          // Has a cloaked host
	int vhost;          // has a vhost

	int invis;          // is invisable
	int priv;           // has PRIVATE mode set hides channels to users
	int admin;	    // user is a Server Admin
	int myconnect;

	time_t	lastsent;

	int lines;
	int ignore;

    char  access[128]; 	    //Access FLAGS

	dlink_list  channels;

	/**
	 * Command structures since we treate our clients
	 * as normal users, we need to store this here
    	 */

	dlink_list cmd_list[1024];    //This users CMDhash :)

    dlink_list help_ext_list[1024];

	dlink_list cmd_help;




};

User* AddUser  (char*,char*,char*,char*,char*,char *,char *, char *, char *);
User* find_user (char*);
User* find_uid  (char *);
User *new_user  (char *);
int AddUserIp	(User*, char *, int);

void exit_user  (char *);

void exit_one_user      (User *, char *);
void exit_local_users	(char *);
void exit_remote_users	(void);
void burst_local_users	(int, char **);

User* NewClient  (char*,char*,char*,char*); //add a service to the network.
int DelClient    (char *);    	        	//remove a service from the network.

void NewNick      (User *,char *);
User* isOurClient (char *);                  //returns if the client is on our server
int CheckIgnore   (User *);

char * create_usermode_string   (User *);
void read_usermode_string       (User *, char *);

struct guardian {
    char    nick[30];
    char    host[63];
    char    desc[50];
    char    user[10];
	dlink_list	chanlist;
} guardian;

User* s_Guardian;
User* s_Scanner;


char *Guardian;

#endif //__USER_H__
