

#include "stdinc.h"
#include "server.h"




#define NAME "m_guardian"
#define AUTHOR "$Author: twitch $"
#define VERSION "$Id: m_guardian.c 1392 2008-09-11 05:45:25Z twitch $"


extern Link* serv_list;
extern User* user_list;
extern Channel* chan_list;
extern Module* module_list;

static int guardian_load();
static void guardian_unload();

static void my_privmsg(User*, int, char**);
static void Guardian_Init();




/***********************************************/

MODHEADER(NAME, VERSION, AUTHOR, MAKE_ABI(0,5,0),guardian_load, NULL);


static int guardian_load()
{

      Guardian_Init();
      AddUserCmd("PRIVMSG", my_privmsg);
      return MOD_CONT;
}


void guardian_unload()
{
	exit(0);
}



/***********************************************/


static void my_privmsg(User* u,int argc, char **msg)
{


	if (*msg[2] != '\001')
		return;

	if (strcasecmp(msg[2],"\001VERSION\001")==0)
	{
		send_line(":%s NOTICE %s :\001VERSION Omega(%s)-%s\001",s_Guardian->nick,u->nick,PACKAGE_VERSION,VERSION_STRING);
		return;
	}

      return;

}

/***********************************************/

static void Guardian_Init()
{
	User    *u;
	Channel	*c;
	char	*chan;
	dlink_node	*dl, *tdl;

    u = NewClient(guardian.nick, guardian.user, guardian.host, guardian.desc);
    if (!u)
    {
	 alog(2,"Unable to assign guardian user...");
   	 Exit(0);
    }

    s_Guardian  = u;


	if (!(c = find_channel (logchan)))
	{
		c		= new_chan (logchan);
		c->channelts	= time(NULL);
	}

	AddToChannelU (s_Guardian, c);

	DLINK_FOREACH_SAFE (dl, tdl, guardian.chanlist.head)
	{
		chan	= dl->data;

		if (!(c = find_channel (chan)))
		{
			c		= new_chan (chan);
			c->channelts	= time(NULL);
		}

		AddToChannelU (s_Guardian, c);
		dl = dlink_find_delete(chan,&guardian.chanlist);
	        dlink_free(dl);
		free(chan);

	}


    return;

}

/***********************************************/




